pipeline {
    agent any
    stages {
        stage('execute ansible playbook') {
            steps{
                script{
                    
                    def remote= [:]
                    remote.name = "ansible-server"
                    remote.host = ${ansible-server}
                    remote.allowAnyHosts = true
        
                    withCredentials([sshUserPrivateKey(credentialsId:'ansible-server',keyFileVariable: 'keyfile',usernameVariable:'user')]){
                        remote.user = user
                        remote.identityFile = keyfile
                        echo "ssh to ansible server to run terraform to provision ec2-instance"
                        sshCommand remote: remote, command: "cd terraform-project && sudo terraform apply --auto-approve"
                        echo "calling ansible playbook to configure ec2-instance"
                        sshCommand remote: remote, command: "cd ansible-project && sudo ansible-playbook -i inventory_aws_ec2.yaml deploy-docker.yaml"
                    }
                }
            }
        }
    } 
}

